// CodeGear C++Builder
// Copyright (c) 1995, 2008 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Printsm.pas' rev: 20.00

#ifndef PrintsmHPP
#define PrintsmHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Smprntr.hpp>	// Pascal unit
#include <Smrtypes.hpp>	// Pascal unit
#include <Smrpeset.hpp>	// Pascal unit
#include <Smrexprt.hpp>	// Pascal unit
#include <Smrcnst.hpp>	// Pascal unit
#include <Smrpars.hpp>	// Pascal unit
#include <Db.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Printsm
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TSMRLangID { lnEnglish, lnRussian, lnUkrainian, lnGerman, lnFrench, lnSpanish, lnSwedish, lnCzech, lnDutch };
#pragma option pop

class DELPHICLASS TSMRLanguage;
class PASCALIMPLEMENTATION TSMRLanguage : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FAutoDetect;
	TSMRLangID FLanguageID;
	bool FAutoDetected;
	TSMRLangID FLangIDByAutoDetect;
	void __fastcall AutoDetectLangID(void);
	
public:
	__fastcall TSMRLanguage(void);
	TSMRLangID __fastcall GetLangID(void);
	
__published:
	__property bool AutoDetect = {read=FAutoDetect, write=FAutoDetect, default=0};
	__property TSMRLangID LanguageID = {read=FLanguageID, write=FLanguageID, default=0};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TSMRLanguage(void) { }
	
};


class DELPHICLASS TPageInfo;
class PASCALIMPLEMENTATION TPageInfo : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	int FPageWidth;
	int FPageHeight;
	void __fastcall SetPageWidth(int Value);
	void __fastcall SetPageHeight(int Value);
	
public:
	int intNumPage;
	int intNumBar;
	int OffsetLeft;
	int OffsetRight;
	int OffsetTop;
	int OffsetBottom;
	Graphics::TMetafile* Data;
	__property int PageWidth = {read=FPageWidth, write=SetPageWidth, nodefault};
	__property int PageHeight = {read=FPageHeight, write=SetPageHeight, nodefault};
public:
	/* TObject.Create */ inline __fastcall TPageInfo(void) : System::TObject() { }
	/* TObject.Destroy */ inline __fastcall virtual ~TPageInfo(void) { }
	
};


#pragma option push -b-
enum TStatus { stIdle, stPrinting, stPrinted };
#pragma option pop

typedef void __fastcall (__closure *TPageEvent)(System::TObject* Sender, int Page, int Bar);

#pragma option push -b-
enum Printsm__3 { ftTop, ftBottom, ftLeft, ftRight };
#pragma option pop

typedef Set<Printsm__3, ftTop, ftRight>  TSMFrameType;

#pragma option push -b-
enum TSMPicType { btNone, btCenter, btStretch, btTile, btTileAsFrame, btCorners };
#pragma option pop

class DELPHICLASS TSMRFrame;
class PASCALIMPLEMENTATION TSMRFrame : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FBottom;
	bool FLeft;
	bool FRight;
	bool FTop;
	Controls::TControl* FParent;
	Graphics::TPenStyle FPenStyle;
	int FWidth;
	Graphics::TColor FColor;
	Graphics::TColor FBackColor;
	Graphics::TPicture* FPicture;
	TSMPicType FPicType;
	void __fastcall SetColor(int Index, Graphics::TColor Value);
	void __fastcall SetParent(Controls::TControl* Value);
	void __fastcall SetStyle(Graphics::TPenStyle Value);
	void __fastcall SetValue(int Index, bool Value);
	void __fastcall SetWidth(int Value);
	TSMFrameType __fastcall GetFrameType(void);
	void __fastcall SetFrameType(TSMFrameType Value);
	void __fastcall SetPicture(Graphics::TPicture* Value);
	
protected:
	void __fastcall SetPen(Graphics::TPen* Value);
	
public:
	__fastcall TSMRFrame(void);
	__fastcall virtual ~TSMRFrame(void);
	bool __fastcall AnyFrame(void);
	int __fastcall GetFrameWidth(void);
	void __fastcall DrawFrame(Graphics::TCanvas* ACanvas, const Types::TRect &ARect);
	__property Controls::TControl* Parent = {read=FParent, write=SetParent};
	__property bool DrawTop = {read=FTop, write=SetValue, index=0, nodefault};
	__property bool DrawBottom = {read=FBottom, write=SetValue, index=1, nodefault};
	__property bool DrawLeft = {read=FLeft, write=SetValue, index=2, nodefault};
	__property bool DrawRight = {read=FRight, write=SetValue, index=3, nodefault};
	
__published:
	__property Graphics::TColor Color = {read=FColor, write=SetColor, index=0, default=0};
	__property Graphics::TPenStyle Style = {read=FPenStyle, write=SetStyle, default=0};
	__property int Width = {read=FWidth, write=SetWidth, default=1};
	__property TSMFrameType FrameType = {read=GetFrameType, write=SetFrameType, default=0};
	__property Graphics::TColor BackColor = {read=FBackColor, write=SetColor, index=1, default=16777215};
	__property Graphics::TPicture* Picture = {read=FPicture, write=SetPicture};
	__property TSMPicType PicType = {read=FPicType, write=FPicType, default=0};
};


#pragma option push -b-
enum TSMROption { roDisableControls };
#pragma option pop

typedef Set<TSMROption, roDisableControls, roDisableControls>  TSMROptions;

class DELPHICLASS TSMPrintBaseComponent;
class PASCALIMPLEMENTATION TSMPrintBaseComponent : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	Classes::TNotifyEvent FBeginDoc;
	Classes::TNotifyEvent FEndDoc;
	TPageEvent FBeginPage;
	TPageEvent FEndPage;
	bool FPrepared;
	TStatus FStatus;
	Classes::TList* FPages;
	Smrexprt::TSMProperty* FSMProperty;
	TSMRFrame* FFrame;
	bool FAnimatedStatus;
	TSMRLanguage* FLanguage;
	Smprntr::TSMRPrinter* FPrinterSetting;
	Smprntr::TSMRPrinter* FOldPrinterSetting;
	Classes::TNotifyEvent FOnBeforePreview;
	Classes::TNotifyEvent FOnPreview;
	Classes::TNotifyEvent FOnAfterPreview;
	Classes::TNotifyEvent FOnBeforePrint;
	Classes::TNotifyEvent FOnAfterPrint;
	bool FTwoPass;
	Smrtypes::TSMRVariables* FVariables;
	Smrtypes::TSMROutlines* FOutlines;
	Smrpars::TGetVariableEvent FOnGetVariable;
	TSMROptions FOptions;
	Classes::THelpContext FHelpContext;
	Classes::TNotifyEvent FOnBeforeFormShow;
	void __fastcall SetVariables(Smrtypes::TSMRVariables* Value);
	void __fastcall SetOutlines(Smrtypes::TSMROutlines* Value);
	void __fastcall SetLanguage(TSMRLanguage* Value);
	void __fastcall SetPrinterSettings(Smprntr::TSMRPrinter* Value);
	void __fastcall SetFrame(TSMRFrame* Value);
	void __fastcall SavePrinter(void);
	void __fastcall RestorePrinter(void);
	TPageInfo* __fastcall GetPage(int intPg, int intBr);
	void __fastcall DrawLogo(void);
	void __fastcall SetSMProperty(Smrexprt::TSMProperty* Value);
	
protected:
	int intMaxPageHeight;
	int intLastPageHeight;
	int intCurHeight;
	int intCurPassNumber;
	int intNumPages;
	int intNumBars;
	int __fastcall GetNumPages(void);
	int __fastcall GetNumBars(void);
	void __fastcall FreePages(void);
	void __fastcall PrintStart(void);
	void __fastcall PrintEnd(void);
	void __fastcall PrepareStart(void);
	void __fastcall PrepareEnd(void);
	virtual void __fastcall PrepareReport(void);
	void __fastcall InternalPreview(bool WithPrepare, Controls::TWinControl* ParentControl);
	System::Variant __fastcall GetSysDataValue(Smrcnst::TSMRSysDataType sdType);
	virtual int __fastcall GetPageNoCountBy(void);
	virtual int __fastcall GetPageNoStartAt(void);
	virtual int __fastcall GetCurColumn(void);
	virtual int __fastcall GetColumnNumber(void);
	virtual void __fastcall SMRGetVariable(System::TObject* Sender, System::UnicodeString VariableName, bool &Accept, Db::TFieldType &VariableType, System::Variant &Value);
	__property bool TwoPass = {read=FTwoPass, write=FTwoPass, default=0};
	__property Classes::TNotifyEvent OnBeforeFormShow = {read=FOnBeforeFormShow, write=FOnBeforeFormShow};
	
public:
	System::UnicodeString ProductVersion;
	int intCurPage;
	int intCurBar;
	Graphics::TMetafileCanvas* MFCanvas;
	__fastcall virtual TSMPrintBaseComponent(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMPrintBaseComponent(void);
	TPageInfo* __fastcall CurrentPage(void);
	virtual void __fastcall BeginDoc(void);
	virtual void __fastcall EndDoc(void);
	virtual void __fastcall NewPage(bool isNewBar);
	void __fastcall Prepare(void);
	void __fastcall PrintPages(Classes::TStrings* lstValidPages);
	void __fastcall PrintReport(void);
	void __fastcall Print(void);
	void __fastcall Preview(void);
	void __fastcall PreviewParentedControl(Controls::TWinControl* ParentControl);
	void __fastcall PreviewParentedControlPreparedReport(Controls::TWinControl* ParentControl);
	void __fastcall PreviewPreparedReport(void);
	void __fastcall LoadPreparedReportFromStream(Classes::TStream* AStream);
	void __fastcall LoadPreparedReport(const System::UnicodeString FileName);
	void __fastcall SavePreparedReportToStream(Classes::TStream* AStream);
	void __fastcall SavePreparedReport(const System::UnicodeString FileName);
	void __fastcall SavePreparedPages(const System::UnicodeString FileName, bool IsSeparatePages, Classes::TStrings* lstValidPages);
	void __fastcall SavePageToFile(System::UnicodeString &AFileName);
	void __fastcall ExportTo(System::UnicodeString FName, bool IsSeparatePages, Classes::TStrings* lstValidPages, Smrexprt::TSMRExportClass smreFilter);
	void __fastcall About(void);
	int __fastcall GetLanguageShift(void);
	System::UnicodeString __fastcall F0D0();
	__property TPageInfo* Pages[int intPg][int intBr] = {read=GetPage};
	__property int NumPages = {read=GetNumPages, nodefault};
	__property int NumBars = {read=GetNumBars, nodefault};
	__property bool AnimatedStatus = {read=FAnimatedStatus, write=FAnimatedStatus, default=1};
	__property TSMRFrame* Frame = {read=FFrame, write=SetFrame};
	__property Smprntr::TSMRPrinter* PrinterSetting = {read=FPrinterSetting, write=SetPrinterSettings};
	__property Smrtypes::TSMROutlines* Outlines = {read=FOutlines, write=SetOutlines};
	__property Smrtypes::TSMRVariables* Variables = {read=FVariables, write=SetVariables};
	__property Smrpars::TGetVariableEvent OnGetVariable = {read=FOnGetVariable, write=FOnGetVariable};
	__property TSMROptions Options = {read=FOptions, write=FOptions, default=1};
	
__published:
	__property TSMRLanguage* Language = {read=FLanguage, write=SetLanguage};
	__property Smrexprt::TSMProperty* SMProperty = {read=FSMProperty, write=SetSMProperty};
	__property Classes::THelpContext HelpContext = {read=FHelpContext, write=FHelpContext, default=0};
	__property Classes::TNotifyEvent OnBeginDoc = {read=FBeginDoc, write=FBeginDoc};
	__property Classes::TNotifyEvent OnEndDoc = {read=FEndDoc, write=FEndDoc};
	__property TPageEvent OnBeginPage = {read=FBeginPage, write=FBeginPage};
	__property TPageEvent OnEndPage = {read=FEndPage, write=FEndPage};
	__property Classes::TNotifyEvent OnPreview = {read=FOnPreview, write=FOnPreview};
	__property Classes::TNotifyEvent OnBeforePreview = {read=FOnBeforePreview, write=FOnBeforePreview};
	__property Classes::TNotifyEvent OnAfterPreview = {read=FOnAfterPreview, write=FOnAfterPreview};
	__property Classes::TNotifyEvent OnBeforePrint = {read=FOnBeforePrint, write=FOnBeforePrint};
	__property Classes::TNotifyEvent OnAfterPrint = {read=FOnAfterPrint, write=FOnAfterPrint};
};


class DELPHICLASS TSMPrintComponent;
class PASCALIMPLEMENTATION TSMPrintComponent : public TSMPrintBaseComponent
{
	typedef TSMPrintBaseComponent inherited;
	
private:
	Graphics::TFont* FFont;
	void __fastcall SetFont(Graphics::TFont* Value);
	
public:
	__fastcall virtual TSMPrintComponent(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMPrintComponent(void);
	__property Graphics::TFont* Font = {read=FFont, write=SetFont};
	
__published:
	__property TwoPass = {default=0};
};


class DELPHICLASS TSMRCompositeReport;
class PASCALIMPLEMENTATION TSMRCompositeReport : public TSMPrintBaseComponent
{
	typedef TSMPrintBaseComponent inherited;
	
private:
	Classes::TList* FReports;
	
public:
	__fastcall virtual TSMRCompositeReport(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMRCompositeReport(void);
	virtual void __fastcall PrepareReport(void);
	int __fastcall AddReport(TSMPrintBaseComponent* SMRep);
	void __fastcall RemoveReport(int i);
	void __fastcall ClearReports(void);
	__property Classes::TList* Reports = {read=FReports, write=FReports};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Printsm */
using namespace Printsm;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// PrintsmHPP
